Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3711)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3712)
@@ -4741,11 +4781,11 @@
               IF ( building_pars_f%pars_xy(ind_thick_4_wall_r,j,i) /= building_pars_f%fill )    & 
                  surf_usm_h%zw_green(nzb_wall+3,m) = building_pars_f%pars_xy(ind_thick_4_wall_r,j,i)
-              IF ( building_pars_f%pars_xy(ind_thick_1_win_r,j,i) /= building_pars_f%fill )    & 
+              IF ( building_pars_f%pars_xy(ind_thick_1_win_r,j,i) /= building_pars_f%fill )     & 
                  surf_usm_h%zw_window(nzb_wall,m) = building_pars_f%pars_xy(ind_thick_1_win_r,j,i)
-              IF ( building_pars_f%pars_xy(ind_thick_2_win_r,j,i) /= building_pars_f%fill )    & 
+              IF ( building_pars_f%pars_xy(ind_thick_2_win_r,j,i) /= building_pars_f%fill )     & 
                  surf_usm_h%zw_window(nzb_wall+1,m) = building_pars_f%pars_xy(ind_thick_2_win_r,j,i)
-              IF ( building_pars_f%pars_xy(ind_thick_3_win_r,j,i) /= building_pars_f%fill )    & 
+              IF ( building_pars_f%pars_xy(ind_thick_3_win_r,j,i) /= building_pars_f%fill )     & 
                  surf_usm_h%zw_window(nzb_wall+2,m) = building_pars_f%pars_xy(ind_thick_3_win_r,j,i)
-              IF ( building_pars_f%pars_xy(ind_thick_4_win_r,j,i) /= building_pars_f%fill )    & 
+              IF ( building_pars_f%pars_xy(ind_thick_4_win_r,j,i) /= building_pars_f%fill )     & 
                  surf_usm_h%zw_window(nzb_wall+3,m) = building_pars_f%pars_xy(ind_thick_4_win_r,j,i)
 
@@ -4783,5 +4823,5 @@
                  ind_alb_win      = MERGE( ind_alb_win_gfl,      ind_alb_win_agfl,      &
                                            surf_usm_v(l)%ground_level(m) )
-                 ind_wall_frac    = MERGE( ind_wall_frac_gfl,    ind_wall_frac_agfl,     &
+                 ind_wall_frac    = MERGE( ind_wall_frac_gfl,    ind_wall_frac_agfl,    &
                                            surf_usm_v(l)%ground_level(m) )
                  ind_win_frac     = MERGE( ind_win_frac_gfl,     ind_win_frac_agfl,     &
@@ -4947,7 +4987,7 @@
                  IF ( building_pars_f%pars_xy(ind_alb_wall,j,i) /= building_pars_f%fill )    & 
                     surf_usm_v(l)%albedo_type(ind_veg_wall,m)  = building_pars_f%pars_xy(ind_alb_wall,j,i)
-                 IF ( building_pars_f%pars_xy(ind_alb_green,j,i) /= building_pars_f%fill )    & 
+                 IF ( building_pars_f%pars_xy(ind_alb_green,j,i) /= building_pars_f%fill )   & 
                     surf_usm_v(l)%albedo_type(ind_pav_green,m) = building_pars_f%pars_xy(ind_alb_green,j,i)
-                 IF ( building_pars_f%pars_xy(ind_alb_win,j,i) /= building_pars_f%fill )    & 
+                 IF ( building_pars_f%pars_xy(ind_alb_win,j,i) /= building_pars_f%fill )     & 
                     surf_usm_v(l)%albedo_type(ind_wat_win,m)   = building_pars_f%pars_xy(ind_alb_win,j,i)
 
@@ -5001,9 +5041,9 @@
         CALL usm_read_urban_surface_types()
         
-!--     init material heat model
         CALL usm_init_material_model()
-        
+!        
 !--     init anthropogenic sources of heat
         IF ( usm_anthropogenic_heat )  THEN
+!
 !--         init anthropogenic sources of heat (from transportation for now)
             CALL usm_read_anthropogenic_heat()
@@ -5046,10 +5086,10 @@
                 surf_usm_v(l)%z0(m) = 0.9_wp * surf_usm_v(l)%z_mo(m)
              
-                WRITE( message_string, * ) 'z0 exceeds surface-layer height '//&
-                            'at vertical urban surface and is ' //             &
-                            'decreased appropriately at grid point (i,j) = ',  &
-                            surf_usm_v(l)%i(m)+surf_usm_v(l)%ioff,             &
+                WRITE( message_string, * ) 'z0 exceeds surface-layer height '// &
+                            'at vertical urban surface and is ' //              &
+                            'decreased appropriately at grid point (i,j) = ',   &
+                            surf_usm_v(l)%i(m)+surf_usm_v(l)%ioff,              &
                             surf_usm_v(l)%j(m)+surf_usm_v(l)%joff
-                CALL message( 'urban_surface_model_mod', 'PA0503',             &
+                CALL message( 'urban_surface_model_mod', 'PA0503',              &
                             0, 0, 0, 6, 0 )
              ENDIF
@@ -5059,17 +5099,18 @@
                 surf_usm_v(l)%z0q(m) = 0.9_wp * surf_usm_v(l)%z_mo(m)
              
-                WRITE( message_string, * ) 'z0h exceeds surface-layer height '//&
-                            'at vertical urban surface and is ' //             &
-                            'decreased appropriately at grid point (i,j) = ',  &
-                            surf_usm_v(l)%i(m)+surf_usm_v(l)%ioff,             &
+                WRITE( message_string, * ) 'z0h exceeds surface-layer height '// &
+                            'at vertical urban surface and is ' //               &
+                            'decreased appropriately at grid point (i,j) = ',    &
+                            surf_usm_v(l)%i(m)+surf_usm_v(l)%ioff,               &
                             surf_usm_v(l)%j(m)+surf_usm_v(l)%joff
-                CALL message( 'urban_surface_model_mod', 'PA0507',             &
+                CALL message( 'urban_surface_model_mod', 'PA0507',               &
                             0, 0, 0, 6, 0 )
              ENDIF
           ENDDO
-       ENDDO    
-
+       ENDDO
+
+!
 !--     Intitialization of the surface and wall/ground/roof temperature
-
+!
 !--     Initialization for restart runs
         IF ( TRIM( initializing_actions ) /= 'read_restart_data'  .AND.        &
@@ -5117,5 +5158,5 @@
                ENDDO
             ENDIF
-      
+!
 !--         initial values for t_wall
 !--         outer value is set to surface temperature
@@ -5172,4 +5213,5 @@
         ENDIF
 
+!
 !--     If specified, replace constant wall temperatures with fully 3D values from file
         IF ( read_wall_temp_3d )  CALL usm_read_wall_temperature()
@@ -5179,4 +5221,5 @@
         CALL user_init_urban_surface
 
+!
 !--     initialize prognostic values for the first timestep
         t_surf_wall_h_p = t_surf_wall_h
@@ -5194,4 +5237,5 @@
         t_green_v_p = t_green_v
 
+!
 !--     Adjust radiative fluxes for urban surface at model start
         !CALL radiation_interaction
@@ -5201,5 +5245,4 @@
         m_liq_usm_h_p     = m_liq_usm_h
         m_liq_usm_v_p     = m_liq_usm_v
-!++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 !
 !--    Set initial values for prognostic quantities
@@ -5230,9 +5273,8 @@
           ENDDO
        ENDIF
-!+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++        
-
-       CALL cpu_log( log_point_s(78), 'usm_init', 'stop' )
-
-       CALL location_message( 'finished', .TRUE. )
+
+        CALL cpu_log( log_point_s(78), 'usm_init', 'stop' )
+
+        CALL location_message( 'finished', .TRUE. )
 
     END SUBROUTINE usm_init
@@ -5243,6 +5285,8 @@
 ! ------------
 !
-!> Wall model as part of the urban surface model. The model predicts wall
-!> temperature.
+!> Wall model as part of the urban surface model. The model predicts vertical
+!> and horizontal wall / roof temperatures and window layer temperatures.
+!> No window layer temperature calculactions during spinup to increase
+!> possible timestep.
 !------------------------------------------------------------------------------!
     SUBROUTINE usm_material_heat_model( spinup )
@@ -5254,15 +5298,15 @@
 
         REAL(wp), DIMENSION(nzb_wall:nzt_wall) :: wtend, wintend  !< tendency
-        REAL(wp)     :: win_absorp !absorption coefficient from transmissivity
+        REAL(wp)     :: win_absorp  !< absorption coefficient from transmissivity
         REAL(wp), DIMENSION(nzb_wall:nzt_wall) :: wall_mod
 
-        LOGICAL      :: spinup !if true, no calculation of window temperatures
+        LOGICAL      :: spinup  !< if true, no calculation of window temperatures
 
         wall_mod=1.0_wp
-        if (usm_wall_mod .AND. spinup) then
-          do kw=nzb_wall,nzb_wall+1
-            wall_mod(kw)=0.1_wp
-          enddo
-        endif
+        IF (usm_wall_mod .AND. spinup) THEN
+           DO  kw=nzb_wall,nzb_wall+1
+               wall_mod(kw)=0.1_wp
+           ENDDO
+        ENDIF
 
 !
@@ -5291,5 +5335,5 @@
                                          * ( surf_usm_h%lambda_h_green(nzt_wall,m)* wall_mod(nzt_wall) &
                                            * surf_usm_h%ddz_green(nzt_wall,m)      &
-                                           + surf_usm_h%lambda_h(nzb_wall,m) * wall_mod(nzb_wall)        &
+                                           + surf_usm_h%lambda_h(nzb_wall,m) * wall_mod(nzb_wall)      &
                                            * surf_usm_h%ddz_wall(nzb_wall,m) )     &
                                          / ( surf_usm_h%ddz_green(nzt_wall,m)      &
@@ -5298,12 +5342,13 @@
                                            - t_green_h(nzt_wall,m) ) ) *           &
                                        surf_usm_h%ddz_wall_stag(nzb_wall,m)
-
-           IF ( indoor_model ) then 
+!
+!-- if indoor model ist used inner wall layer is calculated by using iwghf (indoor wall ground heat flux)
+           IF ( indoor_model ) THEN 
               DO  kw = nzb_wall+1, nzt_wall-1
                   wtend(kw) = (1.0_wp / surf_usm_h%rho_c_wall(kw,m))              &
-                                 * (   surf_usm_h%lambda_h(kw,m) * wall_mod(kw)                 &
+                                 * (   surf_usm_h%lambda_h(kw,m) * wall_mod(kw)   &
                                     * ( t_wall_h(kw+1,m) - t_wall_h(kw,m) )       &
                                     * surf_usm_h%ddz_wall(kw+1,m)                 &
-                                 - surf_usm_h%lambda_h(kw-1,m) * wall_mod(kw-1)                     &
+                                 - surf_usm_h%lambda_h(kw-1,m) * wall_mod(kw-1)   &
                                     * ( t_wall_h(kw,m) - t_wall_h(kw-1,m) )       &
                                     * surf_usm_h%ddz_wall(kw,m)                   &
@@ -5311,5 +5356,5 @@
               ENDDO
               wtend(nzt_wall) = (1.0_wp / surf_usm_h%rho_c_wall(nzt_wall,m)) *    &
-                                         ( -surf_usm_h%lambda_h(nzt_wall-1,m) * wall_mod(nzt_wall-1) *     &
+                                         ( -surf_usm_h%lambda_h(nzt_wall-1,m) * wall_mod(nzt_wall-1) * &
                                            ( t_wall_h(nzt_wall,m)                 &
                                            - t_wall_h(nzt_wall-1,m) ) *           &
@@ -5320,8 +5365,8 @@
               DO  kw = nzb_wall+1, nzt_wall
                   wtend(kw) = (1.0_wp / surf_usm_h%rho_c_wall(kw,m))              &
-                                 * (   surf_usm_h%lambda_h(kw,m)  * wall_mod(kw)                &
+                                 * (   surf_usm_h%lambda_h(kw,m)  * wall_mod(kw)  &
                                     * ( t_wall_h(kw+1,m) - t_wall_h(kw,m) )       &
                                     * surf_usm_h%ddz_wall(kw+1,m)                 &
-                                 - surf_usm_h%lambda_h(kw-1,m) * wall_mod(kw-1)                   &
+                                 - surf_usm_h%lambda_h(kw-1,m) * wall_mod(kw-1)   &
                                     * ( t_wall_h(kw,m) - t_wall_h(kw-1,m) )       &
                                     * surf_usm_h%ddz_wall(kw,m)                   &
@@ -5335,73 +5380,77 @@
                                  * surf_usm_h%tt_wall_m(nzb_wall:nzt_wall,m) )   
 
-if (.NOT. spinup) then
-           win_absorp = -log(surf_usm_h%transmissivity(m)) / surf_usm_h%zw_window(nzt_wall,m)
-!--        prognostic equation for ground/roof window temperature t_window_h
-           wintend(:) = 0.0_wp
-           wintend(nzb_wall) = (1.0_wp / surf_usm_h%rho_c_window(nzb_wall,m)) *   &
-                                      ( surf_usm_h%lambda_h_window(nzb_wall,m) *  &
-                                        ( t_window_h(nzb_wall+1,m)                &
-                                        - t_window_h(nzb_wall,m) ) *              &
-                                        surf_usm_h%ddz_window(nzb_wall+1,m)       &
-                                      + surf_usm_h%wghf_eb_window(m)              &
-                                      + surf_usm_h%rad_sw_in(m)                   &
-                                        * (1.0_wp - exp(-win_absorp               &
-                                        * surf_usm_h%zw_window(nzb_wall,m) ) )    &
-                                      ) * surf_usm_h%ddz_window_stag(nzb_wall,m)
-
-           IF ( indoor_model ) then 
-              DO  kw = nzb_wall+1, nzt_wall-1
-                  wintend(kw) = (1.0_wp / surf_usm_h%rho_c_window(kw,m))          &
-                                 * (   surf_usm_h%lambda_h_window(kw,m)           &
-                                    * ( t_window_h(kw+1,m) - t_window_h(kw,m) )   &
-                                    * surf_usm_h%ddz_window(kw+1,m)               &
-                                 - surf_usm_h%lambda_h_window(kw-1,m)             &
-                                    * ( t_window_h(kw,m) - t_window_h(kw-1,m) )   &
-                                    * surf_usm_h%ddz_window(kw,m)                 &
-                                 + surf_usm_h%rad_sw_in(m)                        &
-                                    * (exp(-win_absorp                            &
-                                        * surf_usm_h%zw_window(kw-1,m) )          &
-                                        - exp(-win_absorp                         &
-                                        * surf_usm_h%zw_window(kw,m) ) )          &
-                                   ) * surf_usm_h%ddz_window_stag(kw,m)
-
-              ENDDO
-              wintend(nzt_wall) = (1.0_wp / surf_usm_h%rho_c_window(nzt_wall,m)) *       &
-                                         ( -surf_usm_h%lambda_h_window(nzt_wall-1,m) *   &
-                                           ( t_window_h(nzt_wall,m)                      &
-                                           - t_window_h(nzt_wall-1,m) ) *                &
-                                           surf_usm_h%ddz_window(nzt_wall,m)             &
-                                         + surf_usm_h%iwghf_eb_window(m)                 &
-                                         + surf_usm_h%rad_sw_in(m)                       &
-                                           * (exp(-win_absorp                            &
-                                           * surf_usm_h%zw_window(nzt_wall-1,m) )        &
-                                           - exp(-win_absorp                             &
-                                           * surf_usm_h%zw_window(nzt_wall,m) ) )        &
-                                         ) * surf_usm_h%ddz_window_stag(nzt_wall,m)
-           ELSE
-              DO  kw = nzb_wall+1, nzt_wall
-                  wintend(kw) = (1.0_wp / surf_usm_h%rho_c_window(kw,m))          &
-                                 * (   surf_usm_h%lambda_h_window(kw,m)           &
-                                    * ( t_window_h(kw+1,m) - t_window_h(kw,m) )   &
-                                    * surf_usm_h%ddz_window(kw+1,m)               &
-                                 - surf_usm_h%lambda_h_window(kw-1,m)             &
-                                    * ( t_window_h(kw,m) - t_window_h(kw-1,m) )   &
-                                    * surf_usm_h%ddz_window(kw,m)                 &
-                                 + surf_usm_h%rad_sw_in(m)                        &
-                                    * (exp(-win_absorp                            &
-                                        * surf_usm_h%zw_window(kw-1,m) )          &
-                                        - exp(-win_absorp                         &
-                                        * surf_usm_h%zw_window(kw,m) ) )          &
-                                   ) * surf_usm_h%ddz_window_stag(kw,m)
-
-              ENDDO
-           ENDIF
-
-           t_window_h_p(nzb_wall:nzt_wall,m) = t_window_h(nzb_wall:nzt_wall,m)    &
+!
+!-- during spinup the tempeature inside window layers is not calculated to make larger timesteps possible
+           IF ( .NOT. spinup) THEN
+              win_absorp = -log(surf_usm_h%transmissivity(m)) / surf_usm_h%zw_window(nzt_wall,m)
+!
+!--           prognostic equation for ground/roof window temperature t_window_h
+!--           takes absorption of shortwave radiation into account
+              wintend(:) = 0.0_wp
+              wintend(nzb_wall) = (1.0_wp / surf_usm_h%rho_c_window(nzb_wall,m)) *   &
+                                         ( surf_usm_h%lambda_h_window(nzb_wall,m) *  &
+                                           ( t_window_h(nzb_wall+1,m)                &
+                                           - t_window_h(nzb_wall,m) ) *              &
+                                           surf_usm_h%ddz_window(nzb_wall+1,m)       &
+                                         + surf_usm_h%wghf_eb_window(m)              &
+                                         + surf_usm_h%rad_sw_in(m)                   &
+                                           * (1.0_wp - exp(-win_absorp               &
+                                           * surf_usm_h%zw_window(nzb_wall,m) ) )    &
+                                         ) * surf_usm_h%ddz_window_stag(nzb_wall,m)
+   
+              IF ( indoor_model ) THEN 
+                 DO  kw = nzb_wall+1, nzt_wall-1
+                     wintend(kw) = (1.0_wp / surf_usm_h%rho_c_window(kw,m))          &
+                                    * (   surf_usm_h%lambda_h_window(kw,m)           &
+                                       * ( t_window_h(kw+1,m) - t_window_h(kw,m) )   &
+                                       * surf_usm_h%ddz_window(kw+1,m)               &
+                                    - surf_usm_h%lambda_h_window(kw-1,m)             &
+                                       * ( t_window_h(kw,m) - t_window_h(kw-1,m) )   &
+                                       * surf_usm_h%ddz_window(kw,m)                 &
+                                    + surf_usm_h%rad_sw_in(m)                        &
+                                       * (exp(-win_absorp                            &
+                                           * surf_usm_h%zw_window(kw-1,m) )          &
+                                           - exp(-win_absorp                         &
+                                           * surf_usm_h%zw_window(kw,m) ) )          &
+                                      ) * surf_usm_h%ddz_window_stag(kw,m)
+   
+                 ENDDO
+                 wintend(nzt_wall) = (1.0_wp / surf_usm_h%rho_c_window(nzt_wall,m)) *       &
+                                            ( -surf_usm_h%lambda_h_window(nzt_wall-1,m) *   &
+                                              ( t_window_h(nzt_wall,m)                      &
+                                              - t_window_h(nzt_wall-1,m) ) *                &
+                                              surf_usm_h%ddz_window(nzt_wall,m)             &
+                                            + surf_usm_h%iwghf_eb_window(m)                 &
+                                            + surf_usm_h%rad_sw_in(m)                       &
+                                              * (exp(-win_absorp                            &
+                                              * surf_usm_h%zw_window(nzt_wall-1,m) )        &
+                                              - exp(-win_absorp                             &
+                                              * surf_usm_h%zw_window(nzt_wall,m) ) )        &
+                                            ) * surf_usm_h%ddz_window_stag(nzt_wall,m)
+              ELSE
+                 DO  kw = nzb_wall+1, nzt_wall
+                     wintend(kw) = (1.0_wp / surf_usm_h%rho_c_window(kw,m))          &
+                                    * (   surf_usm_h%lambda_h_window(kw,m)           &
+                                       * ( t_window_h(kw+1,m) - t_window_h(kw,m) )   &
+                                       * surf_usm_h%ddz_window(kw+1,m)               &
+                                    - surf_usm_h%lambda_h_window(kw-1,m)             &
+                                       * ( t_window_h(kw,m) - t_window_h(kw-1,m) )   &
+                                       * surf_usm_h%ddz_window(kw,m)                 &
+                                    + surf_usm_h%rad_sw_in(m)                        &
+                                       * (exp(-win_absorp                            &
+                                           * surf_usm_h%zw_window(kw-1,m) )          &
+                                           - exp(-win_absorp                         &
+                                           * surf_usm_h%zw_window(kw,m) ) )          &
+                                      ) * surf_usm_h%ddz_window_stag(kw,m)
+   
+                 ENDDO
+              ENDIF
+
+              t_window_h_p(nzb_wall:nzt_wall,m) = t_window_h(nzb_wall:nzt_wall,m) &
                                  + dt_3d * ( tsc(2)                               &
                                  * wintend(nzb_wall:nzt_wall) + tsc(3)            &
                                  * surf_usm_h%tt_window_m(nzb_wall:nzt_wall,m) )   
 
-endif
+           ENDIF
 
 !
@@ -5421,21 +5470,21 @@
            ENDIF
 
-if (.NOT. spinup) then
-!--        calculate t_window tendencies for the next Runge-Kutta step
-           IF ( timestep_scheme(1:5) == 'runge' )  THEN
-               IF ( intermediate_timestep_count == 1 )  THEN
-                  DO  kw = nzb_wall, nzt_wall
-                     surf_usm_h%tt_window_m(kw,m) = wintend(kw)
-                  ENDDO
-               ELSEIF ( intermediate_timestep_count <                          &
-                        intermediate_timestep_count_max )  THEN
-                   DO  kw = nzb_wall, nzt_wall
-                      surf_usm_h%tt_window_m(kw,m) = -9.5625_wp * wintend(kw) +    &
-                                         5.3125_wp * surf_usm_h%tt_window_m(kw,m)
-                   ENDDO
-               ENDIF
+           IF (.NOT. spinup) THEN
+!
+!--           calculate t_window tendencies for the next Runge-Kutta step
+              IF ( timestep_scheme(1:5) == 'runge' )  THEN
+                  IF ( intermediate_timestep_count == 1 )  THEN
+                     DO  kw = nzb_wall, nzt_wall
+                        surf_usm_h%tt_window_m(kw,m) = wintend(kw)
+                     ENDDO
+                  ELSEIF ( intermediate_timestep_count <                            &
+                           intermediate_timestep_count_max )  THEN
+                      DO  kw = nzb_wall, nzt_wall
+                         surf_usm_h%tt_window_m(kw,m) = -9.5625_wp * wintend(kw) +  &
+                                            5.3125_wp * surf_usm_h%tt_window_m(kw,m)
+                      ENDDO
+                  ENDIF
+              ENDIF
            ENDIF
-
-endif
 
         ENDDO
@@ -5454,33 +5503,33 @@
               wtend(:) = 0.0_wp
 
-               wtend(nzb_wall) = (1.0_wp / surf_usm_v(l)%rho_c_wall(nzb_wall,m)) *    &
-                                       ( surf_usm_v(l)%lambda_h(nzb_wall,m) * wall_mod(nzb_wall)  *      &
-                                         ( t_wall_v(l)%t(nzb_wall+1,m)                &
-                                         - t_wall_v(l)%t(nzb_wall,m) ) *              &
-                                         surf_usm_v(l)%ddz_wall(nzb_wall+1,m)         &
-                                       + surf_usm_v(l)%frac(ind_veg_wall,m)           &
-                                         / (surf_usm_v(l)%frac(ind_veg_wall,m)        &
-                                           + surf_usm_v(l)%frac(ind_pav_green,m) )    &
-                                         * surf_usm_v(l)%wghf_eb(m)                   &
-                                       - surf_usm_v(l)%frac(ind_pav_green,m)          &
-                                         / (surf_usm_v(l)%frac(ind_veg_wall,m)        &
-                                           + surf_usm_v(l)%frac(ind_pav_green,m) )    &
-                                         * ( surf_usm_v(l)%lambda_h_green(nzt_wall,m)* wall_mod(nzt_wall) &
-                                           * surf_usm_v(l)%ddz_green(nzt_wall,m)      &
-                                           + surf_usm_v(l)%lambda_h(nzb_wall,m)* wall_mod(nzb_wall)       &
-                                           * surf_usm_v(l)%ddz_wall(nzb_wall,m) )     &
-                                         / ( surf_usm_v(l)%ddz_green(nzt_wall,m)      &
-                                           + surf_usm_v(l)%ddz_wall(nzb_wall,m) )     &
-                                         * ( t_wall_v(l)%t(nzb_wall,m)                &
-                                           - t_green_v(l)%t(nzt_wall,m) ) ) *         &
-                                         surf_usm_v(l)%ddz_wall_stag(nzb_wall,m)
-
-              IF ( indoor_model ) then 
+              wtend(nzb_wall) = (1.0_wp / surf_usm_v(l)%rho_c_wall(nzb_wall,m)) *    &
+                                      ( surf_usm_v(l)%lambda_h(nzb_wall,m) * wall_mod(nzb_wall)  *      &
+                                        ( t_wall_v(l)%t(nzb_wall+1,m)                &
+                                        - t_wall_v(l)%t(nzb_wall,m) ) *              &
+                                        surf_usm_v(l)%ddz_wall(nzb_wall+1,m)         &
+                                      + surf_usm_v(l)%frac(ind_veg_wall,m)           &
+                                        / (surf_usm_v(l)%frac(ind_veg_wall,m)        &
+                                          + surf_usm_v(l)%frac(ind_pav_green,m) )    &
+                                        * surf_usm_v(l)%wghf_eb(m)                   &
+                                      - surf_usm_v(l)%frac(ind_pav_green,m)          &
+                                        / (surf_usm_v(l)%frac(ind_veg_wall,m)        &
+                                          + surf_usm_v(l)%frac(ind_pav_green,m) )    &
+                                        * ( surf_usm_v(l)%lambda_h_green(nzt_wall,m)* wall_mod(nzt_wall) &
+                                          * surf_usm_v(l)%ddz_green(nzt_wall,m)      &
+                                          + surf_usm_v(l)%lambda_h(nzb_wall,m)* wall_mod(nzb_wall)       &
+                                          * surf_usm_v(l)%ddz_wall(nzb_wall,m) )     &
+                                        / ( surf_usm_v(l)%ddz_green(nzt_wall,m)      &
+                                          + surf_usm_v(l)%ddz_wall(nzb_wall,m) )     &
+                                        * ( t_wall_v(l)%t(nzb_wall,m)                &
+                                          - t_green_v(l)%t(nzt_wall,m) ) ) *         &
+                                        surf_usm_v(l)%ddz_wall_stag(nzb_wall,m)
+
+              IF ( indoor_model ) THEN 
                  DO  kw = nzb_wall+1, nzt_wall-1
                      wtend(kw) = (1.0_wp / surf_usm_v(l)%rho_c_wall(kw,m))        &
-                              * (   surf_usm_v(l)%lambda_h(kw,m)  * wall_mod(kw)                &
+                              * (   surf_usm_v(l)%lambda_h(kw,m)  * wall_mod(kw)  &
                                  * ( t_wall_v(l)%t(kw+1,m) - t_wall_v(l)%t(kw,m) )&
                                  * surf_usm_v(l)%ddz_wall(kw+1,m)                 &
-                              - surf_usm_v(l)%lambda_h(kw-1,m)  * wall_mod(kw-1)                  &
+                              - surf_usm_v(l)%lambda_h(kw-1,m)  * wall_mod(kw-1)  &
                                  * ( t_wall_v(l)%t(kw,m) - t_wall_v(l)%t(kw-1,m) )&
                                  * surf_usm_v(l)%ddz_wall(kw,m)                   &
@@ -5497,8 +5546,8 @@
                  DO  kw = nzb_wall+1, nzt_wall
                      wtend(kw) = (1.0_wp / surf_usm_v(l)%rho_c_wall(kw,m))        &
-                              * (   surf_usm_v(l)%lambda_h(kw,m) * wall_mod(kw)                 &
+                              * (   surf_usm_v(l)%lambda_h(kw,m) * wall_mod(kw)   &
                                  * ( t_wall_v(l)%t(kw+1,m) - t_wall_v(l)%t(kw,m) )&
                                  * surf_usm_v(l)%ddz_wall(kw+1,m)                 &
-                              - surf_usm_v(l)%lambda_h(kw-1,m)  * wall_mod(kw-1)                  &
+                              - surf_usm_v(l)%lambda_h(kw-1,m)  * wall_mod(kw-1)  &
                                  * ( t_wall_v(l)%t(kw,m) - t_wall_v(l)%t(kw-1,m) )&
                                  * surf_usm_v(l)%ddz_wall(kw,m)                   &
